/*
compile with gcc Secure_seeding_with_devrandom.c

This code is simplified code taken from: 
https://insanecoding.blogspot.com/2014/05/a-good-idea-with-bad-usage-devurandom.html
This VERY NICE blog discusses more problems! 
*/

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>

void bits(int val){
	int i;
	for(i = 0; i < 8*sizeof(int); i++){
		printf("%d", (val >> i)&1);
	}
	printf("\n");
}

int main( int argc, char *argv[]){
	int i, B_requested = sizeof(int), B_obtained = 0, B_read;
	unsigned int seed = -1; 
	int file = open("/dev/random", O_RDONLY);
	
	while (B_requested >  B_obtained)
	{
		B_read = read(file, ((unsigned char*)&seed) + B_obtained, B_requested - B_obtained);
		if (B_read < 0) {/* error, unable to read /dev/random*/}
		else {B_obtained += B_read;}
	}	
	close(file);
	
	bits(seed);
	
	srand(seed);
	for(i=0; i < 10; i++)
	{
		printf("%d ", rand());
	}
	return 0;

}